#include <iostream>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    long long dan, razlika, t, o = 0;
    cin >> n >> q;
    long long k[q], d[n], p[n], r[q];
    for(int i = 0; i < n; i++) cin >> d[i] >> p[i];
    for(int i = 0; i < q; i++) cin >> k[i];
    int w;
    for(w = 0; w < q; w++) {
        if(d[0] > k[w]) r[w] = 0;
        else break;
    }
    dan = d[0];
    r[w] = 0;
    for(int i = 0; i < n; i++) {
        if(d[i] > k[w]) {
            w++; 
            r[w] = r[w-1];
        }
        if(dan >= d[i] && i != 0) {
            dan += p[i];
            if(dan>=k[w]) {
                do {
                    o = dan - k[w];
                    r[w] += p[i] - o;
                    p[i] -= p[i] - o;
                    w++;
                    r[w] = r[w-1];
                    if(w >= q) break;
                } while(o > 0);
            }
            else r[w] += p[i];
        }
        else {
            dan = d[i] + p[i] - 1;
            if(dan >= k[w]) {
                o = dan - k[w];
                while(o > 0 && dan >= k[w]) {
                    o = dan - k[w];
                    r[w] += p[i] - o;
                    p[i] -= p[i] - o;
                    w++;
                    r[w] = r[w-1];
                    if(w >= q) break;
                }
                if(o > 0) r[w] += o;
            }
            else r[w] += p[i];
        }
    }
    for(int i = 0; i < q; i++) cout << r[i] << endl;

    return 0;
}